#ifndef __CORE_H_INCLUDED_SW__
#define __CORE_H_INCLUDED_SW__

#include "platform.h"

#ifdef __cplusplus
	extern "C" {
#endif 

	#define		FCN_NONE			0
	#define		FCN_AVERAGE			1
	#define		FCN_ENVELOPE		2 
	#define		FCN_SIGNIFICANCE	3 

	// type of file, also used as type information for data stored in a VIDINFHDR
	#define		TYPE_NONE_EMPTY		-1
	#define		TYPE_CHOOSE			 0
	#define		TYPE_IMM			 1
	#define		TYPE_IMC			 2 
	#define		TYPE_BKG			 3
	#define		TYPE_BKC			 4
	#define		TYPE_SIGNIFICANCE	 5

	// required structure

	struct VIDINFHDR
	{
		UINT32	width;
		UINT32	height;
		UINT32	bpp;
		UINT32	bpp_effective;
	
		DOUBLE	scale;
	
		INT32	numframes;
	
		INT32	type; // FILE_

		VOID  **framebits;
		DOUBLE *framescales;
	};

	extern void	initialize_vidinfhdr	( struct VIDINFHDR *vinf );
	extern void	free_vidinfhdr			( struct VIDINFHDR *vinf );

#ifdef __cplusplus
	}
#endif 

#endif // __CORE_H_INCLUDED_SW__
