#ifndef __GETFRAMES_H_INCLUDED_SW__
#define __GETFRAMES_H_INCLUDED_SW__

#include "platform.h"

// the two exported functions from getframes.c
extern INT32 grabframes( const CHAR *servername, const UINT16 net_port, UINT32 num_frames, struct VIDINFHDR *vinf);
extern INT32 convert_format( struct VIDINFHDR *vinf, UINT32 newtype, UINT32 downscale_function);

// declare _timeb structure (for timestamp inside VIDHDR)
typedef struct
{
	UINT32	time;            // time since Jan 1st, 1970 in seconds
	UINT16	millitm; // milliseconds which have to be added to time_t
	INT16		timezone;         // is not used in this program
	INT16		dstflag;          // is not used in this program
	CHAR		reserved[2];
} _timeb; 

#define		REAL_SIZE_TIMEB		12

// declare video header (before every frame on socket connection)
typedef struct {
	UINT32	kennung;        // 0x11223344;
	UINT32	compression;    // FOURCC codec name
	UINT32	len_total;      // length of data + formatheader + vidhdr
	UINT32	len_data;       // length of the data (compressed image) 
	UINT32	len_fmthdr;     // length of the format header (needed for decompression on windows side)
	UINT32	frameno;        /* since starting the grabbing on the grabserver 
						    (note: each camera change results in restarting grabbing) */
	
	_timeb	timestamp;      // _timeb structure
	UINT32	cameraport;     // port of the camera (0..3)
	UINT32	widthframe;     // width of the frame
	UINT32	heightframe;    // height of the frame
	UINT32	compressed;     /* 1= picture is compressed
							    0= picture is not compressed because if it would be compressed 
								it would be too big                                            */
	CHAR	reserved[12]; 

	DOUBLE	scale;
	UINT32	bpp;
	UINT32  bpp_effective;	    // willbe used as bits per pixel effective (12bpp e.g.)
	
	CHAR	reserved1[8];
} VIDHDR;

// total size of the video header before each frame in bytes (88 bytes)
#define		REAL_SIZE_VIDHDR	88

#endif // __GETFRAMES_H_INCLUDED_SW__
