#ifndef __PLATFORM_H_INCLUDED_SW__
#define __PLATFORM_H_INCLUDED_SW__

// includes and declarations that are platform-specific

// Windows (Win32) platform wrapper includes and declarations


// windows includes

#include <stdio.h>
#include <stdlib.h>
#ifdef WINNT
#include <winsock2.h>
#endif

#ifndef VOID
	#define		VOID			void
#endif

#ifndef VOIDP
	typedef		void	*		VOIDP;
#endif

#ifndef INT32
	typedef		int				INT32;
#endif

#ifndef UINT32
	typedef		unsigned int	UINT32;
#endif

#ifndef DOUBLE
	typedef		double			DOUBLE;
#endif

#ifndef CHAR
	typedef		char			CHAR;
#endif

#ifndef UCHAR
	typedef		unsigned char	UCHAR; 
#endif

#ifndef UINT16
	typedef		unsigned short	UINT16;
#endif

#ifndef INT16
	typedef		signed short	INT16;
#endif

//#ifndef time_t
//	typedef		int				time_t;
//#endif

#ifndef socktype
	typedef		int				socktype;
#endif

//#ifndef DWORD
//	typedef		unsigned long	DWORD;
//#endif

// win32: already defined
//extern const	INT32	SOCKET_ERROR;
//extern const	INT32	INVALID_SOCKET;

#define EADDRNOTAVAIL	-3
#define EAFNOSUPPORT	-4
#define EALREADY		-5
#define EBADF			-6
#define ECONNREFUSED	-7
#define EINPROGRESS		-8
#define EINTR			-9
#define EISCONN			-10
#define ENETUNREACH		-11
#define ENOTSOCK		-12
#define EPROTOTYPE		-13
#define ETIMEDOUT		-14
#define EADDRINUSE		-15
#define ECONNRESET		-16
#define EHOSTUNREACH	-17
#define EINVAL			-18
#define ENAMETOOLONG	-19
#define ENETDOWN		-20

//(SW! !!! July 31, 2006)
#define EAGAIN			-21 
//(SW! !!! July 31, 2006)
#define EUNKNOWN		-22 
#define EHOSTDOWN		-23

// function declarations required for getframes.c

extern		INT32		getlasterror();
#ifdef SOCKET_STUFF
extern		socktype	create_inet_socket( INT32 type );
extern		INT32		receive_socket_function( socktype s, UCHAR *buf, UINT32 buflen);
extern		INT32		close_socket( socktype s);
extern		INT32		connect_socket(socktype s, const struct sockaddr * Saddr, size_t size_sockaddr);
extern		INT32		set_socket_nonblocking ( socktype s );

extern		VOID		sleep_milliseconds(UINT32 milliseconds);
#endif

#endif //__PLATFORM_H_INCLUDED_SW__
